<?php
/* intopstudio.ru */
error_reporting(E_ALL);
ini_set("display_errors", 1);

if (!defined('_PS_VERSION_')) {
    exit;
}

class OrderFormSimpliFied extends Module
{
    public $hooks = array(
        'displayBeforeCarrier',
    );

    public function __construct()
    {
        $this->name                   = 'orderformsimplified';
        $this->tab                    = 'checkout';
        $this->version                = '1.0';
        $this->author                 = 'intopstudio.ru';
        $this->need_instance          = 0;
        $this->bootstrap              = true;
        $this->limited_countries      = array('ru');
        $this->ps_versions_compliancy = array('min' => '1.5', 'max' => '1.6');
        parent::__construct();

        $this->displayName = $this->l('Упрощенная регистрация');
        $this->description = $this->l('Упрощенная регистрация в форме быстрого заказа');
    }

    public function install()
    {
        Configuration::updateValue('OFF_NEW_ACCOUNT_TITLE', ('0'));
        Configuration::updateValue('OFF_GENDER', ('1'));
        Configuration::updateValue('OFF_DATE_SELECT', ('1'));
        Configuration::updateValue('OFF_NEWSLETTER', ('0'));
        Configuration::updateValue('OFF_FIRSTNAME_LASTNAME', ('1'));
        Configuration::updateValue('OFF_COMPANY', ('1'));
        Configuration::updateValue('OFF_ADDRESS1', ('0'));
        Configuration::updateValue('OFF_CITY', ('0'));
        Configuration::updateValue('OFF_COUNTRY', ('1'));
        Configuration::updateValue('OFF_PHONE', ('0'));
        Configuration::updateValue('OFF_INVOICE_ADDRESS', ('0'));
        Configuration::updateValue('OFF_LABEL', ('1'));
        $sql   = array();
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "country` SET `display_tax_label` = '0', `need_zip_code` = '0', `zip_code_format` = ''";
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "configuration` SET `value` = '1' WHERE `" . _DB_PREFIX_ . "configuration`.`name` ='PS_ORDER_PROCESS_TYPE'";
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "configuration` SET `value` = '1' WHERE `" . _DB_PREFIX_ . "configuration`.`name` ='PS_GUEST_CHECKOUT_ENABLED'";
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "configuration` SET `value` = '0' WHERE `" . _DB_PREFIX_ . "configuration`.`name` ='PS_CUSTOMER_NWSL'";
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "configuration` SET `value` = '0' WHERE `" . _DB_PREFIX_ . "configuration`.`name` ='PS_CUSTOMER_OPTIN'";
        $sql[] = "UPDATE `" . _DB_PREFIX_ . "configuration` SET `value` = '0' WHERE `" . _DB_PREFIX_ . "configuration`.`name` ='PS_ONE_PHONE_AT_LEAST'";
        foreach ($sql as $s) {
            if (!Db::getInstance()->Execute($s)) {
                $this->_errors[] = "Failed on SQL Query";
                return false;
            }
        }

        if (!parent::install()) {
            $this->_errors[] = "Failed on module install";
            return false;
        }
        if (!$this->registerHooks()) {
            $this->_errors[] = "Failed on registerHooks";
            return false;
        }
        return true;
    }

    public function registerHooks()
    {
        foreach ($this->hooks as $hook) {
            if (!$this->registerHook($hook)) {
                $this->_errors[] = "Failed to install hook '$hook'<br />\n";
                return false;
            }
        }
        return true;
    }
    public function unregisterHooks()
    {
        foreach ($this->hooks as $hook) {
            if (!$this->unregisterHook($hook)) {
                $this->_errors[] = "Failed to uninstall hook '$hook'<br />\n";
                return false;
            }
        }
        return true;
    }

    public function uninstall()
    {
        if (!parent::uninstall()) {
            return false;
        }

        return true;
    }

    public function processConfiguration()
    {
        if (Tools::isSubmit('off_form')) {
            $off_new_account_title = Tools::getValue('off_new_account_title');
            Configuration::updateValue('OFF_NEW_ACCOUNT_TITLE', $off_new_account_title);

            $off_gender = Tools::getValue('off_gender');
            Configuration::updateValue('OFF_GENDER', $off_gender);

            $off_date_select = Tools::getValue('off_date_select');
            Configuration::updateValue('OFF_DATE_SELECT', $off_date_select);

            $off_newsletter = Tools::getValue('off_newsletter');
            Configuration::updateValue('OFF_NEWSLETTER', $off_newsletter);

            $off_firstname_lastname = Tools::getValue('off_firstname_lastname');
            Configuration::updateValue('OFF_FIRSTNAME_LASTNAME', $off_firstname_lastname);

            $off_company = Tools::getValue('off_company');
            Configuration::updateValue('OFF_COMPANY', $off_company);

            $off_address1 = Tools::getValue('off_address1');
            Configuration::updateValue('OFF_ADDRESS1', $off_address1);

            $off_city = Tools::getValue('off_city');
            Configuration::updateValue('OFF_CITY', $off_city);

            $off_country = Tools::getValue('off_country');
            Configuration::updateValue('OFF_COUNTRY', $off_country);

            $off_phone = Tools::getValue('off_phone');
            Configuration::updateValue('OFF_PHONE', $off_phone);

            $off_invoice_address = Tools::getValue('off_invoice_address');
            Configuration::updateValue('OFF_INVOICE_ADDRESS', $off_invoice_address);

            $off_label = Tools::getValue('off_label');
            Configuration::updateValue('OFF_LABEL', $off_label);
        }

    }
    public function getContent()
    {
        $this->processConfiguration();
        {
            $message = '';
            if (Tools::isSubmit('submit_' . $this->name)) {
                $message = $this->_saveContent();
            }

            $this->_displayContent($message);
            return $this->display(__FILE__, 'getContent.tpl');
        }

    }

    private function _saveContent()
    {
        $message = '';
        return $message;
    }

    private function _displayContent($message)
    {
        $this->context->smarty->assign(array(
            'OFF_NEW_ACCOUNT_TITLE'  => Configuration::get('OFF_NEW_ACCOUNT_TITLE'),
            'OFF_GENDER'             => Configuration::get('OFF_GENDER'),
            'OFF_DATE_SELECT'        => Configuration::get('OFF_DATE_SELECT'),
            'OFF_NEWSLETTER'         => Configuration::get('OFF_NEWSLETTER'),
            'OFF_FIRSTNAME_LASTNAME' => Configuration::get('OFF_FIRSTNAME_LASTNAME'),
            'OFF_COMPANY'            => Configuration::get('OFF_COMPANY'),
            'OFF_ADDRESS1'           => Configuration::get('OFF_ADDRESS1'),
            'OFF_CITY'               => Configuration::get('OFF_CITY'),
            'OFF_COUNTRY'            => Configuration::get('OFF_COUNTRY'),
            'OFF_PHONE'              => Configuration::get('OFF_PHONE'),
            'OFF_INVOICE_ADDRESS'    => Configuration::get('OFF_INVOICE_ADDRESS'),
            'OFF_LABEL'              => Configuration::get('OFF_LABEL'),
        ));
    }

    public function hookdisplayBeforeCarrier($params)
    {
        $this->context->controller->addCSS($this->_path . '/css/off.css', 'all');

        $off_new_account_title = Configuration::get('OFF_NEW_ACCOUNT_TITLE');
        if ($off_new_account_title == 1) {
            $this->context->controller->addCSS($this->_path . '/css/off_new_account_title.css', 'all');
        }

        $off_gender = Configuration::get('OFF_GENDER');
        if ($off_gender == 1) {
            $this->context->controller->addCSS($this->_path . '/css/off_gender.css', 'all');
        }

        $off_date_select = Configuration::get('OFF_DATE_SELECT');
        if ($off_date_select == 1) {
            $this->context->controller->addCSS($this->_path . '/css/off_date_select.css', 'all');
        }

        $off_newsletter = Configuration::get('OFF_NEWSLETTER');
        if ($off_newsletter == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_newsletter.js', 'all');
        }

        $off_firstname_lastname = Configuration::get('OFF_FIRSTNAME_LASTNAME');
        if ($off_firstname_lastname == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_firstname_lastname.js', 'all');
        }

        $off_company = Configuration::get('OFF_COMPANY');
        if ($off_company == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_company.js', 'all');
        }

        $off_address1 = Configuration::get('OFF_ADDRESS1');
        if ($off_address1 == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_address1.js', 'all');
        }

        $off_city = Configuration::get('OFF_CITY');
        if ($off_city == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_city.js', 'all');
        }

        $off_country = Configuration::get('OFF_COUNTRY');
        if ($off_country == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_country.js', 'all');
            $this->context->controller->addCSS($this->_path . '/css/off_country.css', 'all');}

        $off_phone = Configuration::get('OFF_PHONE');
        if ($off_phone == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_phone.js', 'all');
        }

        $off_invoice_address = Configuration::get('OFF_INVOICE_ADDRESS');
        if ($off_invoice_address == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_invoice_address.js', 'all');
        }

        $off_label = Configuration::get('OFF_LABEL');
        if ($off_label == 1) {
            $this->context->controller->addJS($this->_path . '/js/off_label.js', 'all');
        }

        return;
    }
}
